<?xml version="1.0"?>
<ruleset name="EXT:certification PHPMD ruleset"
         xmlns="http://pmd.sf.net/ruleset/1.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://pmd.sf.net/ruleset/1.0.0 http://pmd.sf.net/ruleset_xml_schema.xsd"
         xsi:noNamespaceSchemaLocation="http://pmd.sf.net/ruleset_xml_schema.xsd"
>
    <description>
        Adapted the phpmd default config.
        * Import all rule sets
        * Allow static access to TYPO3 stuff
        * Allow variables as long as 25 chars
    </description>

    <rule ref="rulesets/codesize.xml" />
    <rule ref="rulesets/controversial.xml" />
    <rule ref="rulesets/design.xml" />
    <rule ref="rulesets/naming.xml">
        <exclude name="LongVariable" />
    </rule>
    <rule ref="rulesets/naming.xml/LongVariable">
        <properties>
            <property name="maximum" value="25" />
        </properties>
    </rule>
    <rule ref="rulesets/unusedcode.xml" />
    <rule ref="rulesets/cleancode.xml">
        <exclude name="StaticAccess" />
    </rule>
    <rule ref="rulesets/cleancode.xml/StaticAccess">
        <properties>
            <property name="exceptions">
                <value>
                    \DateTime,
                    \DateInterval,
                    \DateTimeZone,
                    \TYPO3\CMS\Core\Utility\GeneralUtility,
                    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility
                </value>
            </property>
        </properties>
    </rule>
</ruleset>
